#ifndef _DIRENT_H
#define _DIRENT_H

/* dirent.h - private header for directory entries */

#if __POCC__ >= 500
#pragma once
#endif

#include <sys/types.h>

/* type definitions */
typedef struct _dirent_dir _DIR;

struct _dirent {
    _ino_t d_ino;
    char d_name[260];
};

/* declarations */
int  __cdecl _closedir(_DIR *);  /* WINCE: in crtce.lib */
_DIR * __cdecl _opendir(const char *);  /* WINCE: in crtce.lib */
struct _dirent * __cdecl _readdir(_DIR *);  /* WINCE: in crtce.lib */
void __cdecl _rewinddir(_DIR *);  /* WINCE: in crtce.lib */

/* compatibility names */
#ifdef __POCC__OLDNAMES
typedef struct _dirent_dir DIR;

struct dirent {
    ino_t d_ino;
    char d_name[260];
};

int  __cdecl closedir(DIR *);
DIR * __cdecl opendir(const char *);
struct dirent * __cdecl readdir(DIR *);
void __cdecl rewinddir(DIR *);
#endif /* __POCC__OLDNAMES */

#endif /* _DIRENT_H */
