#include "containers.h"
extern void _stdcall RaiseException(unsigned long,unsigned long, unsigned long, void **);
void ContainerRaiseError(char *fnname,unsigned errcode)
{
	char *arg;
	void *args[2];
	switch(errcode) {
		case CONTAINER_ERROR_BADARG:
			arg = "Bad argument";
			break;
		case CONTAINER_ERROR_NOMEMORY:
			arg = "Insufficient memory";
			break;
		case CONTAINER_ERROR_INDEX:
			arg = "Index error";
			break;
		default:
			arg = "Unknown error";
			break;
	}
	args[0] = arg;
	args[1] = fnname;
	RaiseException(errcode,0,2,args);
}
