#ifndef _SETJMP_H
#define _SETJMP_H

/* setjmp.h - C99 standard header */

#if __POCC__ >= 500
#pragma once
#endif

#ifndef _WINCE

#if __POCC_TARGET__ == 3

/* macros */
#define setjmp(env)  _setjmp((env),0)

/* type definitions */
typedef struct __declspec(align(16)) {
    unsigned long long data[2];
} jmp_buf[16];

/* declarations */
int __cdecl _setjmp(jmp_buf, int);
void __declspec(noreturn) __cdecl longjmp(jmp_buf, int);

#else /* __POCC_TARGET__ != 3 */

/* macros */
#define setjmp(env)  _setjmp3((env),0)

/* type definitions */
typedef int jmp_buf[16];

/* declarations */
int __cdecl _setjmp3(jmp_buf, int);  /* MS compatible */
void __declspec(noreturn) __cdecl longjmp(jmp_buf, int);

#endif /* __POCC_TARGET__ != 3 */

#else /* _WINCE */

/* type definitions */
typedef int jmp_buf[16];

/* declarations */
int __cdecl setjmp(jmp_buf);
void __declspec(noreturn) __cdecl longjmp(jmp_buf, int);

#endif /* _WINCE */

#endif /* _SETJMP_H */
